﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GliderRemoteCompat {
	partial class ClientLogHandler {
		public class GlobalHelper {
			private static readonly Dictionary<string, string> cache = new Dictionary<string, string>();
			private static readonly Type type = typeof(ClientLogHandler);

			public string this[string key] {
				get {
					string val = "";

					if (!cache.TryGetValue(key, out val)) {
						try {
							val = (string)type.GetField(key).GetValue(null);
							cache[key] = val;
						} catch {
							val = "";
						}
					} else if (null == val) {
						val = "";
					}

					return val;
				}
			}
		}

		public static readonly GlobalHelper _G = new GlobalHelper();

		public const int MAX_WOW_CHAT_CHANNELS = 10;

		// http://wowprogramming.com/utils/xmlbrowser/test/FrameXML/GlobalStrings.lua
		public const string
			BN_BROADCAST_TOOLTIP = "Send a Broadcast message to your Real ID and BattleTag friends.",
			BN_CHAT_CONNECTED = "You are now connected to Battle.net.",
			BN_CHAT_DISCONNECTED = "You have been disconnected from Battle.net.",
			BN_CONVERSATION = "Real ID Conversation",
			BN_INLINE_TOAST_ALERT = "Battle.net Alerts",
			// removed "|TInterface..." from BN_*
			BN_INLINE_TOAST_BATTLETAG_FRIEND_ADDED = "%s is now a BattleTag friend.",
			BN_INLINE_TOAST_BATTLETAG_FRIEND_REMOVED = "%s is no longer a BattleTag friend.",
			BN_INLINE_TOAST_BROADCAST = "%s: %s",
			BN_INLINE_TOAST_BROADCAST_INFORM = "Your broadcast has been sent.",
			BN_INLINE_TOAST_CONVERSATION = "You are now in a conversation with %s.",
			BN_INLINE_TOAST_FRIEND_ADDED = "%s is now a Real ID friend.",
			BN_INLINE_TOAST_FRIEND_OFFLINE = "%s has gone offline.",
			BN_INLINE_TOAST_FRIEND_ONLINE = "%s has come online.",
			BN_INLINE_TOAST_FRIEND_PENDING = "You have %s friend |4request:requests;.",
			BN_INLINE_TOAST_FRIEND_REMOVED = "%s is no longer a Real ID friend.",
			BN_INLINE_TOAST_FRIEND_REQUEST = "You have received a new friend request.",
			BN_TOAST_CONVERSATION = "You have joined",
			BN_TOAST_NEW_INVITE = "You have received a new friend request.",
			BN_TOAST_OFFLINE = "has gone |cffff0000offline|r.",
			BN_TOAST_ONLINE = "has come |cff00ff00online|r.",
			BN_TOAST_PENDING_INVITES = "You have |cff82c5ff%d|r friend |4request:requests;.",
			BN_UNABLE_TO_RESOLVE_NAME = "Unable to whisper '%s'. Battle.net may be unavailable.",
			BN_WHISPER = "Battle.net Whispers",
			BN_WHISPER_MODE = "New Battle.net Whispers",

			CHAT = "Chat",
			CHATCONFIG_HEADER = "%s Config",
			CHATLOGDISABLED = "Chat logging disabled.",
			CHATLOGENABLED = "Chat being logged to Logs\\WoWChatLog.txt",
			CHAT_AFK_GET = "%s is Away: ",
			CHAT_ANNOUNCE = "Announce",
			CHAT_ANNOUNCEMENTS_OFF_NOTICE = "|Hchannel:%d|h[%s]|h Channel announcements disabled by %s.",
			CHAT_ANNOUNCEMENTS_OFF_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Channel announcements disabled by %s.",
			CHAT_ANNOUNCEMENTS_ON_NOTICE = "|Hchannel:%d|h[%s]|h Channel announcements enabled by %s.",
			CHAT_ANNOUNCEMENTS_ON_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Channel announcements enabled by %s.",
			CHAT_AUTO_JOIN = "Auto Join",
			CHAT_BAN = "Ban",
			CHAT_BANNED_NOTICE = "[%s] You are banned from that channel.",
			CHAT_BN_CONVERSATION_GET = "%s: ",
			CHAT_BN_CONVERSATION_GET_LINK = "|Hchannel:BN_CONVERSATION:%d|h[%s. Conversation]|h",
			CHAT_BN_CONVERSATION_LIST = "%s %s",
			CHAT_BN_CONVERSATION_SEND = "[%d. Conversation]:",
			CHAT_BN_WHISPER_GET = "%s whispers: ",
			CHAT_BN_WHISPER_INFORM_GET = "To %s: ",
			CHAT_BN_WHISPER_SEND = "Tell %s: ",
			CHAT_BUBBLES_TEXT = "Chat Bubbles",
			CHAT_CHANNELS = "Chat Channels",
			CHAT_CHANNEL_GET = "%s: ",
			CHAT_CHANNEL_JOIN_GET = "%s joined channel.",
			CHAT_CHANNEL_LEAVE_GET = "%s left channel.",
			CHAT_CHANNEL_LIST_GET = "|Hchannel:CHANNEL:%d|h[%s]|h ",
			CHAT_CHANNEL_OWNER_NOTICE = "|Hchannel:%d|h[%s]|h Channel owner is %s.",
			CHAT_CHANNEL_OWNER_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Channel owner is %s.",
			CHAT_CHANNEL_SEND = "[%d. %s]: ",
			CHAT_COMBAT_MISC_INFO_GET = "",
			CHAT_CONFIGURATION = "Settings",
			CHAT_CONVERSATION_CONVERSATION_CONVERTED_TO_WHISPER_NOTICE = "%s has been converted to a whisper with %s.",
			CHAT_CONVERSATION_MEMBER_JOINED_NOTICE = "%s: %s has joined the conversation.",
			CHAT_CONVERSATION_MEMBER_LEFT_NOTICE = "%s: %s left the conversation.",
			CHAT_CONVERSATION_YOU_JOINED_CONVERSATION_NOTICE = "You joined %s.",
			CHAT_CONVERSATION_YOU_LEFT_CONVERSATION_NOTICE = "You left %s.",
			CHAT_DEFAULT = "Default",
			CHAT_DEFAULTS = "Chat Defaults",
			CHAT_DEMOTE = "Demote",
			CHAT_DND_GET = "%s does not wish to be disturbed: ",
			CHAT_EMOTE_GET = "%s ",
			CHAT_EMOTE_SEND = "%s ",
			CHAT_EMOTE_UNKNOWN = "makes some strange gestures.",
			CHAT_FILTERED = "Unable to send chat to %s because your message contained reserved words.",
			CHAT_FLAG_AFK = "<Away>",
			CHAT_FLAG_COM = "<Com>",
			CHAT_FLAG_DND = "<Busy>",
			CHAT_FLAG_GM = "<GM>",
			CHAT_GUILD_DEMOTE_SEND = "Demote",
			CHAT_GUILD_GET = "|Hchannel:GUILD|h[Guild]|h %s: ",
			CHAT_GUILD_INVITE_SEND = "Invite to guild: ",
			CHAT_GUILD_LEADER_SEND = "Set guild leader: ",
			CHAT_GUILD_MOTD_SEND = "Guild MOTD: ",
			CHAT_GUILD_PROMOTE_SEND = "Promote ",
			CHAT_GUILD_SEND = "Guild: ",
			CHAT_GUILD_UNINVITE_SEND = "Remove from guild: ",
			CHAT_HEADER_SUFFIX = ": ",
			CHAT_HELP_TEXT_LINE1 = "Chat commands:",
			CHAT_HELP_TEXT_LINE10 = "/mute, /squelch, /unvoice, /unmute, /unsquelch, /voice <channel> <player> - change a player's permission",
			CHAT_HELP_TEXT_LINE11 = "/cinvite, /chatinvite <channel> <player> - invite a player to a channel",
			CHAT_HELP_TEXT_LINE12 = "/ckick <channel> <player> - kick a player off a channel",
			CHAT_HELP_TEXT_LINE13 = "/ban, /unban <channel> <player> - ban/unban a player from a channel",
			CHAT_HELP_TEXT_LINE14 = "/announce, /ann <channel> - toggle join/leave announcements on a channel",
			CHAT_HELP_TEXT_LINE15 = "/moderate <channel> - toggle moderation on a channel",
			CHAT_HELP_TEXT_LINE16 = "/away, /busy - Set your Away or Busy flags",
			CHAT_HELP_TEXT_LINE2 = "/#, /c, /csay - Send text to channel # (E.G. /1 Hi!)",
			CHAT_HELP_TEXT_LINE3 = "/chat, /chathelp - This help",
			CHAT_HELP_TEXT_LINE4 = "/join, /channel, /chan - Join a channel",
			CHAT_HELP_TEXT_LINE5 = "/leave, /chatleave, /chatexit [channel] - Leave a channel (or all channels)",
			CHAT_HELP_TEXT_LINE6 = "/chatlist, /chatwho, /chatinfo [channel] - List channels, or channel members",
			CHAT_HELP_TEXT_LINE7 = "/password, /pass <channel> <password> - Change password",
			CHAT_HELP_TEXT_LINE8 = "/owner <channel> [player] - Display or change channel owner",
			CHAT_HELP_TEXT_LINE9 = "/mod, /moderator, /unmod, /unmoderator <channel> <player> - change a player's moderator status",
			CHAT_IGNORED = "%s is ignoring you.",
			CHAT_INSTANCE_CHAT_GET = "|Hchannel:INSTANCE_CHAT|h[Instance]|h %s: ",
			CHAT_INSTANCE_CHAT_LEADER_GET = "|Hchannel:INSTANCE_CHAT|h[Instance Leader]|h %s: ",
			CHAT_INSTANCE_CHAT_SEND = "Instance: ",
			CHAT_INVALID_NAME_NOTICE = "Invalid channel name",
			CHAT_INVITE_NOTICE = "%2$s has invited you to join the channel '%1$s'.",
			CHAT_INVITE_NOTICE_POPUP = "%2$s has invited you to join the channel '%1$s'.",
			CHAT_INVITE_SEND = "Invite ",
			CHAT_INVITE_WRONG_FACTION_NOTICE = "Target is in the wrong alliance for %s.",
			CHAT_JOIN = "Join",
			CHAT_JOIN_HELP = "Type /join <channelname> [password] to create a channel or join an existing one.",
			CHAT_KICK = "Kick",
			CHAT_LABEL = "Chat",
			CHAT_LEAVE = "Leave",
			CHAT_LOCKED_TEXT = "Lock Chat Settings",
			CHAT_MODERATE = "Moderate",
			CHAT_MODERATION_OFF_NOTICE = "|Hchannel:%d|h[%s]|h Channel moderation disabled by %s.",
			CHAT_MODERATION_OFF_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Channel moderation disabled by %s.",
			CHAT_MODERATION_ON_NOTICE = "|Hchannel:%d|h[%s]|h Channel moderation enabled by %s.",
			CHAT_MODERATION_ON_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Channel moderation enabled by %s.",
			CHAT_MONSTER_EMOTE_GET = "",
			CHAT_MONSTER_PARTY_GET = "|Hchannel:PARTY|h[Party]|h %s: ",
			CHAT_MONSTER_SAY_GET = "%s says: ",
			CHAT_MONSTER_WHISPER_GET = "%s whispers: ",
			CHAT_MONSTER_YELL_GET = "%s yells: ",
			CHAT_MOUSE_WHEEL_SCROLL = "Enable Mouse Wheel Scrolling",
			CHAT_MSG_ACHIEVEMENT = "Achievement Announce",
			CHAT_MSG_AFK = "Away",
			CHAT_MSG_BATTLEGROUND = "Battleground",
			CHAT_MSG_BATTLEGROUND_LEADER = "Battleground Leader",
			CHAT_MSG_BG_SYSTEM_ALLIANCE = "Alliance zone message",
			CHAT_MSG_BG_SYSTEM_HORDE = "Horde zone message",
			CHAT_MSG_BG_SYSTEM_NEUTRAL = "Neutral zone message",
			CHAT_MSG_BN_CONVERSATION = "Real ID Conversation",
			CHAT_MSG_BN_WHISPER = "Real ID Whisper",
			CHAT_MSG_CHANNEL_LIST = "Channel List",
			CHAT_MSG_COMBAT_HONOR_GAIN = "Honor Gain",
			CHAT_MSG_EMOTE = "Emote",
			CHAT_MSG_FILTERED = "Chat Filtered Message",
			CHAT_MSG_GUILD = "Guild",
			CHAT_MSG_GUILD_ACHIEVEMENT = "Guild Announce",
			CHAT_MSG_LOOT = "Item Loot",
			CHAT_MSG_MONEY = "Money Loot",
			CHAT_MSG_MONSTER_EMOTE = "Creature Emote",
			CHAT_MSG_MONSTER_PARTY = "Creature Party",
			CHAT_MSG_MONSTER_SAY = "Creature Say",
			CHAT_MSG_MONSTER_WHISPER = "Creature Whisper",
			CHAT_MSG_MONSTER_YELL = "Creature Yell",
			CHAT_MSG_OFFICER = "Officer",
			CHAT_MSG_PARTY = "Party",
			CHAT_MSG_PARTY_LEADER = "Party Leader",
			CHAT_MSG_RAID = "Raid",
			CHAT_MSG_RAID_BOSS_EMOTE = "Raid Boss Emote",
			CHAT_MSG_RAID_LEADER = "Raid Leader",
			CHAT_MSG_RAID_WARNING = "Raid Warning",
			CHAT_MSG_RESTRICTED = "Restricted",
			CHAT_MSG_SAY = "Say",
			CHAT_MSG_SKILL = "Skill",
			CHAT_MSG_SYSTEM = "System",
			CHAT_MSG_TEXT_EMOTE = "Text Emote",
			CHAT_MSG_WHISPER = "Incoming Whisper",
			CHAT_MSG_WHISPER_INFORM = "Whisper",
			CHAT_MSG_WORLDDEFENSE_FORMAT = "[%s] %s",
			CHAT_MSG_YELL = "Yell",
			CHAT_MUTED_NOTICE = "|Hchannel:%d|h[%s]|h You do not have permission to speak.",
			CHAT_MUTED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h You do not have permission to speak.",
			CHAT_NAME_TEMPLATE = "Chat %d",
			CHAT_NOT_IN_AREA_NOTICE = "[%s] You are not in the correct area for this channel.",
			CHAT_NOT_MEMBER_NOTICE = "Not on channel %s.",
			CHAT_NOT_MODERATED_NOTICE = "%s is not moderated",
			CHAT_NOT_MODERATOR_NOTICE = "Not a moderator of |Hchannel:%d|h[%s]|h.",
			CHAT_NOT_MODERATOR_NOTICE_BN = "Not a moderator of |Hchannel:CHANNEL:%d|h[%s]|h.",
			CHAT_NOT_OWNER_NOTICE = "|Hchannel:%d|h[%s]|h You are not the channel owner.",
			CHAT_NOT_OWNER_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h You are not the channel owner.",
			CHAT_OFFICER_GET = "|Hchannel:OFFICER|h[Officer]|h %s: ",
			CHAT_OFFICER_SEND = "Officer: ",
			CHAT_OPTIONS_LABEL = "Chat Options",
			CHAT_OVERFLOW_LABEL = "List All Tabs",
			CHAT_OWNER = "Make Owner",
			CHAT_OWNER_CHANGED_NOTICE = "|Hchannel:%d|h[%s]|h Owner changed to %s.",
			CHAT_OWNER_CHANGED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Owner changed to %s.",
			CHAT_PARTY_GET = "|Hchannel:PARTY|h[Party]|h %s: ",
			CHAT_PARTY_GUIDE_GET = "|Hchannel:PARTY|h[Dungeon Guide]|h %s: ",
			CHAT_PARTY_LEADER_GET = "|Hchannel:PARTY|h[Party Leader]|h %s: ",
			CHAT_PARTY_SEND = "Party: ",
			CHAT_PASSWORD = "Set Password",
			CHAT_PASSWORD_CHANGED_NOTICE = "|Hchannel:%d|h[%s]|h Password changed by %s.",
			CHAT_PASSWORD_CHANGED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Password changed by %s.",
			CHAT_PASSWORD_NOTICE_POPUP = "Please enter a password for '%1$s'.",
			CHAT_PET_BATTLE_COMBAT_LOG_GET = "|Hchannel:PET_BATTLE_COMBAT_LOG|h[Pet Battle]|h: ",
			CHAT_PET_BATTLE_INFO_GET = "|Hchannel:PET_BATTLE_INFO|h[Pet Battle]|h: ",
			CHAT_PLAYER_ALREADY_MEMBER_NOTICE = "|Hchannel:%d|h[%s]|h Player %s is already on the channel.",
			CHAT_PLAYER_ALREADY_MEMBER_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Player %s is already on the channel.",
			CHAT_PLAYER_BANNED_NOTICE = "|Hchannel:%d|h[%s]|h Player %s banned by %s.",
			CHAT_PLAYER_BANNED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Player %s banned by %s.",
			CHAT_PLAYER_INVITED_NOTICE = "|Hchannel:%d|h[%s]|h You invited %s to join the channel",
			CHAT_PLAYER_INVITED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h You invited %s to join the channel.",
			CHAT_PLAYER_INVITE_BANNED_NOTICE = "|Hchannel:%d|h[%s]|h %s has been banned.",
			CHAT_PLAYER_INVITE_BANNED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h %s has been banned.",
			CHAT_PLAYER_KICKED_NOTICE = "|Hchannel:%d|h[%s]|h Player %s kicked by %s.",
			CHAT_PLAYER_KICKED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Player %s kicked by %s.",
			CHAT_PLAYER_NOT_BANNED_NOTICE = "|Hchannel:%d|h[%s]|h Player %s is not banned.",
			CHAT_PLAYER_NOT_BANNED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Player %s is not banned.",
			CHAT_PLAYER_NOT_FOUND_NOTICE = "|Hchannel:%d|h[%s]|h Player %s was not found.",
			CHAT_PLAYER_NOT_FOUND_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Player %s was not found.",
			CHAT_PLAYER_UNBANNED_NOTICE = "|Hchannel:%d|h[%s]|h Player %s unbanned by %s.",
			CHAT_PLAYER_UNBANNED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Player %s unbanned by %s.",
			CHAT_PROMOTE = "Promote",
			CHAT_PROMOTE_SEND = "Promote ",
			CHAT_RAID_BOSS_EMOTE_GET = "",
			CHAT_RAID_BOSS_WHISPER_GET = "",
			CHAT_RAID_GET = "|Hchannel:RAID|h[Raid]|h %s: ",
			CHAT_RAID_LEADER_GET = "|Hchannel:RAID|h[Raid Leader]|h %s: ",
			CHAT_RAID_SEND = "Raid: ",
			CHAT_RAID_WARNING_GET = "[Raid Warning] %s: ",
			CHAT_RAID_WARNING_SEND = "Raid Warning: ",
			CHAT_RESTRICTED = "A Starter Edition account may only send whispers to characters that have you on their friends list.  |cffffd000|HurlIndex:2|h[Click To Upgrade]|h|r",
			CHAT_SAY_GET = "%s says: ",
			CHAT_SAY_SEND = "Say: ",
			CHAT_SAY_UNKNOWN = "says something unintelligible.",
			CHAT_SERVER_DISCONNECTED_MESSAGE = "You have been disconnected from the Chat Server and may be unable to send or receive messages.",
			CHAT_SERVER_RECONNECTED_MESSAGE = "You have been reconnected to the Chat Server and may send or receive messages.",
			CHAT_SET_MODERATOR_NOTICE = "|Hchannel:%d|h[%s]|h Moderation privileges given to %s.",
			CHAT_SET_MODERATOR_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Moderation privileges given to %s.",
			CHAT_SET_SPEAK_NOTICE = "|Hchannel:%d|h[%s]|h Voice permission given to %s.",
			CHAT_SET_SPEAK_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Voice permission given to %s.",
			CHAT_SET_VOICE_NOTICE = "|Hchannel:%d|h[%s]|h Chat permission given to %s.",
			CHAT_SET_VOICE_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Chat permission given to %s.",
			CHAT_SILENCE = "Silence in Channel",
			CHAT_STYLE = "Chat Style",
			CHAT_SUSPENDED_NOTICE = "Left Channel: |Hchannel:%d|h[%s]|h ",
			CHAT_SUSPENDED_NOTICE_BN = "Left Channel: |Hchannel:CHANNEL:%d|h[%s]|h",
			CHAT_THROTTLED_NOTICE = "|Hchannel:%d|h[%s]|h The number of messages that can be sent to this channel is limited, please wait to send another message.",
			CHAT_THROTTLED_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h The number of messages that can be sent to this channel is limited, please wait to send another message.",
			CHAT_TRIAL_RESTRICTED_NOTICE = "|Hchannel:%d|h[%s]|h Starter Edition accounts cannot send messages to this channel. |cffffd000|HurlIndex:2|h[Click To Upgrade]|h|r",
			CHAT_UNINVITE_SEND = "Uninvite ",
			CHAT_UNSET_MODERATOR_NOTICE = "|Hchannel:%d|h[%s]|h Moderation privileges removed from %s.",
			CHAT_UNSET_MODERATOR_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Moderation privileges removed from %s.",
			CHAT_UNSET_SPEAK_NOTICE = "|Hchannel:%d|h[%s]|h %s lost voice permission.",
			CHAT_UNSET_SPEAK_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h %s lost voice permission.",
			CHAT_UNSET_VOICE_NOTICE = "|Hchannel:%d|h[%s]|h %s lost chat permission.",
			CHAT_UNSET_VOICE_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h %s lost chat permission.",
			CHAT_UNSILENCE = "Unsilence in Channel",
			CHAT_VOICE = "Voice Chat",
			CHAT_VOICE_OFF = "Disable Voice",
			CHAT_VOICE_OFF_NOTICE = "|Hchannel:%d|h[%s]|h Channel voice disabled by %s.",
			CHAT_VOICE_OFF_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Channel voice disabled by %s.",
			CHAT_VOICE_ON = "Enable Voice",
			CHAT_VOICE_ON_NOTICE = "|Hchannel:%d|h[%s]|h Channel voice enabled by %s.",
			CHAT_VOICE_ON_NOTICE_BN = "|Hchannel:CHANNEL:%d|h[%s]|h Channel voice enabled by %s.",
			CHAT_WHISPER_GET = "%s whispers: ",
			CHAT_WHISPER_INFORM_GET = "To %s: ",
			CHAT_WHISPER_SEND = "Tell %s: ",
			CHAT_WHOLE_WINDOW_CLICKABLE = "Click to Focus",
			CHAT_WINDOWS_COUNT = "%d Chat Windows",
			CHAT_WRONG_FACTION_NOTICE = "Wrong alliance for %s.",
			CHAT_WRONG_PASSWORD_NOTICE = "Wrong password for %s.",
			CHAT_YELL_GET = "%s yells: ",
			CHAT_YELL_SEND = "Yell: ",
			CHAT_YELL_UNKNOWN = "yells at his team members.",
			CHAT_YELL_UNKNOWN_FEMALE = "yells at her team members.",
			CHAT_YOU_CHANGED_NOTICE = "Changed Channel: |Hchannel:%d|h[%s]|h",
			CHAT_YOU_CHANGED_NOTICE_BN = "Changed Channel: |Hchannel:CHANNEL:%d|h[%s]|h",
			CHAT_YOU_JOINED_NOTICE = "Joined Channel: |Hchannel:%d|h[%s]|h",
			CHAT_YOU_JOINED_NOTICE_BN = "Joined Channel: |Hchannel:CHANNEL:%d|h[%s]|h",
			CHAT_YOU_LEFT_NOTICE = "Left Channel: |Hchannel:%d|h[%s]|h",
			CHAT_YOU_LEFT_NOTICE_BN = "Left Channel: |Hchannel:CHANNEL:%d|h[%s]|h"
			;

		private static readonly string[] ChatEvents = {
			"BN_BLOCK_FAILED_TOO_MANY",
			"BN_BLOCK_LIST_UPDATED",
			"BN_CHAT_CHANNEL_CLOSED",
			"BN_CHAT_CHANNEL_CREATE_FAILED",
			"BN_CHAT_CHANNEL_CREATE_SUCCEEDED",
			"BN_CHAT_CHANNEL_INVITE_FAILED",
			"BN_CHAT_CHANNEL_INVITE_SUCCEEDED",
			"BN_CHAT_CHANNEL_JOINED",
			"BN_CHAT_CHANNEL_LEFT",
			"BN_CHAT_CHANNEL_MEMBER_JOINED",
			"BN_CHAT_CHANNEL_MEMBER_LEFT",
			"BN_CHAT_CHANNEL_MEMBER_UPDATED",
			"BN_CHAT_CHANNEL_MESSAGE_BLOCKED",
			"BN_CHAT_CHANNEL_MESSAGE_UNDELIVERABLE",
			"BN_CHAT_WHISPER_UNDELIVERABLE",
			"BN_CONNECTED",
			"BN_CUSTOM_MESSAGE_CHANGED",
			"BN_CUSTOM_MESSAGE_LOADED",
			"BN_DISCONNECTED",
			"BN_FRIEND_ACCOUNT_OFFLINE",
			"BN_FRIEND_ACCOUNT_ONLINE",
			"BN_FRIEND_INFO_CHANGED",
			"BN_FRIEND_INVITE_ADDED",
			"BN_FRIEND_INVITE_LIST_INITIALIZED",
			"BN_FRIEND_INVITE_REMOVED",
			"BN_FRIEND_INVITE_SEND_RESULT",
			"BN_FRIEND_LIST_SIZE_CHANGED",
			"BN_FRIEND_TOON_OFFLINE",
			"BN_FRIEND_TOON_ONLINE",
			"BN_INFO_CHANGED",
			"BN_MATURE_LANGUAGE_FILTER",
			"BN_NEW_PRESENCE",
			"BN_REQUEST_FOF_FAILED",
			"BN_REQUEST_FOF_SUCCEEDED",
			"BN_SELF_OFFLINE",
			"BN_SELF_ONLINE",
			"BN_SYSTEM_MESSAGE",
			"BN_TOON_NAME_UPDATED",
			
			"CHAT_MSG_ACHIEVEMENT",
			//"CHAT_MSG_ADDON",
			"CHAT_MSG_AFK",
			"CHAT_MSG_BG_SYSTEM_ALLIANCE",
			"CHAT_MSG_BG_SYSTEM_HORDE",
			"CHAT_MSG_BG_SYSTEM_NEUTRAL",
			"CHAT_MSG_BN_CONVERSATION",
			"CHAT_MSG_BN_CONVERSATION_LIST",
			"CHAT_MSG_BN_CONVERSATION_NOTICE",
			"CHAT_MSG_BN_INLINE_TOAST_ALERT",
			"CHAT_MSG_BN_INLINE_TOAST_BROADCAST",
			"CHAT_MSG_BN_INLINE_TOAST_BROADCAST_INFORM",
			"CHAT_MSG_BN_INLINE_TOAST_CONVERSATION",
			"CHAT_MSG_BN_WHISPER",
			"CHAT_MSG_BN_WHISPER_INFORM",
			"CHAT_MSG_BN_WHISPER_PLAYER_OFFLINE",
			"CHAT_MSG_CHANNEL",
			"CHAT_MSG_CHANNEL_JOIN",
			"CHAT_MSG_CHANNEL_LEAVE",
			"CHAT_MSG_CHANNEL_LIST",
			"CHAT_MSG_CHANNEL_NOTICE",
			"CHAT_MSG_CHANNEL_NOTICE_USER",
			"CHAT_MSG_COMBAT_FACTION_CHANGE",
			"CHAT_MSG_COMBAT_GUILD_XP_GAIN",
			"CHAT_MSG_COMBAT_HONOR_GAIN",
			"CHAT_MSG_COMBAT_MISC_INFO",
			"CHAT_MSG_COMBAT_XP_GAIN",
			"CHAT_MSG_CURRENCY",
			"CHAT_MSG_DND",
			"CHAT_MSG_EMOTE",
			"CHAT_MSG_FILTERED",
			"CHAT_MSG_GUILD",
			"CHAT_MSG_GUILD_ACHIEVEMENT",
			"CHAT_MSG_IGNORED",
			"CHAT_MSG_INSTANCE_CHAT",
			"CHAT_MSG_INSTANCE_CHAT_LEADER",
			"CHAT_MSG_LOOT",
			"CHAT_MSG_MONEY",
			"CHAT_MSG_MONSTER_EMOTE",
			"CHAT_MSG_MONSTER_PARTY",
			"CHAT_MSG_MONSTER_SAY",
			"CHAT_MSG_MONSTER_WHISPER",
			"CHAT_MSG_MONSTER_YELL",
			"CHAT_MSG_OFFICER",
			"CHAT_MSG_OPENING",
			"CHAT_MSG_PARTY",
			"CHAT_MSG_PARTY_LEADER",
			"CHAT_MSG_PET_BATTLE_COMBAT_LOG",
			"CHAT_MSG_PET_BATTLE_INFO",
			"CHAT_MSG_PET_INFO",
			"CHAT_MSG_RAID",
			"CHAT_MSG_RAID_BOSS_EMOTE",
			"CHAT_MSG_RAID_BOSS_WHISPER",
			"CHAT_MSG_RAID_LEADER",
			"CHAT_MSG_RAID_WARNING",
			"CHAT_MSG_RESTRICTED",
			"CHAT_MSG_SAY",
			"CHAT_MSG_SKILL",
			"CHAT_MSG_SYSTEM",
			"CHAT_MSG_TARGETICONS",
			"CHAT_MSG_TEXT_EMOTE",
			"CHAT_MSG_TRADESKILLS",
			"CHAT_MSG_WHISPER",
			"CHAT_MSG_WHISPER_INFORM",
			"CHAT_MSG_YELL",
			"CHAT_SERVER_DISCONNECTED",
			"CHAT_SERVER_RECONNECTED"
		};
	}
}
